#include <stdio.h>
#include <string.h>
#include <fcntl.h>
#include "md5.h"

extern void MD5Init();
extern void MD5Update();
extern void MD5Final();

/*  perform the MD5 message digest/checksum on file (descriptor) fd. 
 *  return char ptr to 32 hexchar message digest.
 */

char *
calc_MD(filename)
char	*filename;
{

#define LENBUF (7*512)
	MD5_CTX mdContext;
	char buf[LENBUF];
	int fd, lb, i;
	static char s[33];

	if( (fd = open(filename,O_RDONLY)) == -1 )
	{
		fprintf(stderr,"calc_MD: cannot open %s\n",filename);
		return(NULL);
	}

	MD5Init (&mdContext);
	while ((lb = read (fd, buf, 1024)) > 0)
	{
		MD5Update (&mdContext, buf, lb);
	}
	close(fd);
	if( lb == -1 )
	{
		fprintf(stderr,"calc_MD: cannot read %s\n",filename);
		return(NULL);
	}
	MD5Final (&mdContext);

	for (i = 0; i < 16; i++)
		sprintf (&s[i*2], "%02X", mdContext.digest[i]);
	s[i*2]='\0';

#ifdef MDDEBUG
	printf("\nDEBUG: md5 string value:\n");
	printf("%s\n",s);
#endif 
	return(s);
}
